texture2D texColor <
	string type = "input";
>;
texture2D texTarget <
	string type = "output";
>;
sampler2D samplerColor
{
	Texture = <texColor>;
	MinFilter = Linear; MagFilter = Linear; MipFilter = Point;
	AddressU = Clamp; AddressV = Clamp;
};
sampler2D samplerTarget
{
	Texture = <texTarget>;
	MinFilter = Linear; MagFilter = Linear; MipFilter = Point;
	AddressU = Clamp; AddressV = Clamp;
};

// --------------------------------------------------------- \\

struct VS_INPUT
{
	float4 pos : POSITION;
	float2 tex : TEXCOORD0;
};
struct VS_OUTPUT
{
	float4 pos : SV_POSITION;
	float2 tex : TEXCOORD0;
};

// --------------------------------------------------------- \\

VS_OUTPUT PostProcess_VS(VS_INPUT IN)
{
	VS_OUTPUT OUT;
	
	OUT.pos = IN.pos;
	OUT.tex = IN.tex;
	
	return OUT;
}
float4 PostProcess_PS_Target(VS_OUTPUT OUT) : COLOR0
{
	// COLOR0 --> Rendertarget 1
	// COLOR1 --> Rendertarget 2
	// ...
	
	return tex2D(samplerColor, OUT.tex) * float4(OUT.tex, 1.0, 1.0);
}
float4 PostProcess_PS(VS_OUTPUT OUT) : COLOR0
{
	float4 color = tex2D(samplerTarget, OUT.tex);
	color.a = 1.0;
	
	return color;
}

// --------------------------------------------------------- \\

technique PostProcess
{
	pass p0 < string output0 = "texTarget"; >
	{
		VertexShader = compile vs_3_0 PostProcess_VS();
		PixelShader = compile ps_3_0 PostProcess_PS_Target();
	}
	pass p1
	{
		VertexShader = compile vs_3_0 PostProcess_VS();
		PixelShader = compile ps_3_0 PostProcess_PS();
	}
}